SystemOrganization addCategory: #'Roassal2-Plugins-CProjectVisualizer'!

RTTest subclass: #CPPFileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer'!

!CPPFileTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/7/2016 15:39'!
testFileReference

	self assert: CPPFile new fileReference notNil! !

!CPPFileTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/7/2016 15:38'!
testFilename
	self assert: CPPFile new filename equals: 'UNAMED'.
	self assert: (CPPFile new filename: 'foo.h'; filename) equals: 'foo.h'.! !

!CPPFileTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/7/2016 15:36'!
testLOC

	self assert: CPPFile new loc equals: -1.
	self assert: (CPPFile new loc: 10; loc) equals: 10! !

!CPPFileTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/7/2016 15:33'!
testPrintOn

	self assert: CPPFile new printString equals: 'a CPPFile<UNAMED>'! !

RTTest subclass: #CPPFolderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer'!

!CPPFolderTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/7/2016 15:48'!
testBasic
	self assert: CPPFolder new numberOfFiles equals: 0! !

RTTest subclass: #CPPProcessorTest
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer'!

!CPPProcessorTest methodsFor: 'code example' stamp: 'AlexandreBergel 11/3/2016 19:12'!
file01
	^ 
'
#include <foo.h>

void main() { 
}
'! !

!CPPProcessorTest methodsFor: 'code example' stamp: 'AlexandreBergel 11/3/2016 19:12'!
file02
	^ 
'
// Foo.h
'! !

!CPPProcessorTest methodsFor: 'code example' stamp: 'AlexandreBergel 11/3/2016 19:13'!
file03
	^ 
'
#include <foo.h>
#include <foo2.h>
#include <bar.h>

void zork() { 
}
'! !

!CPPProcessorTest methodsFor: 'code example' stamp: 'AlexandreBergel 11/3/2016 19:47'!
file04
	^ 
'
// bar.h
#include <foo.h>
#include <foo2.h>

void zork();
'! !

!CPPProcessorTest methodsFor: 'code example' stamp: 'AlexandreBergel 11/3/2016 20:02'!
file05
	^ 
'
#include "foo.h"

'! !

!CPPProcessorTest methodsFor: 'running' stamp: 'AlexandreBergel 11/3/2016 19:13'!
setUp
	super setUp.
	p := CPPProcessor new! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 19:49'!
testBasic
	| m h |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 1.
	self assert: p numberOfModules equals: 1.
	
	m := p modules anyOne.
	h := p headers anyOne.
	self assert: m loc equals: self file01 lines size.
	self assert: h loc equals: self file02 lines size.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'foo.h'.
	
	self assert: m baseFilenameWithoutExtension equals: 'foo'.
	self assert: h baseFilenameWithoutExtension equals: 'foo'.	
	
	self assert: m hasHeader.
	self assert: m header equals: h.
	self assert: h hasModule.
	self assert: h module equals: m.

	self assert: h incomingHeaders isEmpty.
	self assert: h outgoingHeaders isEmpty.
! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 19:32'!
testBasic02
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.

	self assert: (p moduleNamed: 'foo.c') equals: p modules anyOne.
	self assert: (p headerNamed: 'foo.h') equals: p headers anyOne.
	self assert: (p moduleNamed: 'foo.h') isNil.
	self assert: (p headerNamed: 'foo.c') isNil.! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 19:48'!
testBasic03
	| h1 h2 |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.
	p processFileAsString: self file03 named: 'bar.c'.
	p processFileAsString: self file04 named: 'bar.h'.
	p resolveDependencies.
	
	self assert: p numberOfHeaders equals: 2.
	self assert: p numberOfModules equals: 2.
	
	h1 := p headerNamed: 'bar.h'.
	h2 := p headerNamed: 'foo.h'.
	self assert: h1 incomingHeaders isEmpty.
	self assert: h1 outgoingHeaders size equals: 1.
	
	self assert: h2 incomingHeaders size equals: 1.
	self assert: h2 incomingHeaders anyOne equals: h1.! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 19:52'!
testBasic04
	| m1  m2 |
	p processFileAsString: self file01 named: 'foo.c'.
	p processFileAsString: self file02 named: 'foo.h'.
	p processFileAsString: self file03 named: 'bar.c'.
	p processFileAsString: self file04 named: 'bar.h'.
	p resolveDependencies.
	
	m1 := p moduleNamed: 'bar.c'.
	m2 := p moduleNamed: 'foo.c'.
	self assert: m1 dependentModules size equals: 1.
	self assert: m1 dependentModules anyOne equals: m2.
	
	self assert: m2 dependentModules size equals: 0! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 20:10'!
testBasic05
	| m |
	p processFileAsString: self file05 named: 'foo.c'.
	p resolveDependencies.
	m := p moduleNamed: 'foo.c'.
	self assert: m includedNames size equals: 1.
	self assert: m includedNames anyOne equals: 'foo.h'! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 20:12'!
testBasic06
	| m1  m2 |
	p processFileAsString: self file01 named: '/abc/def/foo.c'.
	p processFileAsString: self file02 named: '/abc/def/foo.h'.
	p processFileAsString: self file03 named: '/abc/def/bar.c'.
	p processFileAsString: self file04 named: '/abc/def/bar.h'.
	p resolveDependencies.
	
	m1 := p moduleNamed: 'bar.c'.
	m2 := p moduleNamed: 'foo.c'.
	self assert: m1 notNil.
	self assert: m2 notNil.
	
	self assert: m1 dependentModules size equals: 1.
	self assert: m1 dependentModules anyOne equals: m2.
	
	self assert: m2 dependentModules size equals: 0! !

!CPPProcessorTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/3/2016 19:14'!
testDefault

	self assert: p numberOfHeaders equals: 0.
	self assert: p numberOfModules equals: 0.! !

RTUsefulScript subclass: #RTVisualizeCPPApplicationScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer'!

!RTVisualizeCPPApplicationScript methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:02'!
description
	^ 
'Let you select a directory containing a C or C++ application and visualize it.
'! !

!RTVisualizeCPPApplicationScript methodsFor: 'hooks' stamp: 'AutoDeprecationRefactoring 11/3/2016 20:30'!
execute
	| s source |
	s := (self class >> #sourceCodeScript) sourceCode.
	source := String cr join: s lines allButFirst.
	GTPlayground openContents: source! !

!RTVisualizeCPPApplicationScript methodsFor: 'hooks' stamp: 'AlexandreBergel 11/3/2016 19:02'!
label
	^ 'Visualize C/C++ application'! !

!RTVisualizeCPPApplicationScript methodsFor: 'script' stamp: 'AlexandreBergel 11/3/2016 20:43'!
sourceCodeScript
	"The following code shows dependencies between "
	| root p b |
	root := '/Users/alexandrebergel/Desktop/SUCHAI'.
	p := CPPProcessor new.
	p processRootFolder: root asFileReference.
	p resolveDependencies.
	
	b := RTMondrian new.
	b shape circle 
		color: Color gray;
		if: [ :f | '*RTOS*' match: f filename ] color: Color red.
	b interaction highlightNeighbour:  #dependentModules color: Color orange .
"	b shape box size: #loc."
	b nodes: p modules.
	
	
	b shape line 
		color: (Color blue alpha: 0.2);
		width: 2.
	b edges 
		moveBehind;
		connectToAll: #dependentModules.
	b layout grid.
	"b layout forceWithCharge: -300."
	
	b normalizer normalizeSize: #loc.
	b! !

RTObject subclass: #CPPAbstractFile
	instanceVariableNames: 'filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer'!

!CPPAbstractFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:42'!
fileReference
	"Return the file reference"
	^ fileReference! !

!CPPAbstractFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:42'!
fileReference: anObject
	fileReference := anObject! !

!CPPAbstractFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:42'!
filename
	^ filename! !

!CPPAbstractFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:42'!
filename: afileName
	filename := afileName.
	fileReference := afileName asFileReference! !

CPPAbstractFile subclass: #CPPFile
	instanceVariableNames: 'includedNames incomingHeaders outgoingHeaders loc fileReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer'!

!CPPFile methodsFor: 'adding' stamp: 'AlexandreBergel 11/7/2016 15:42'!
addIncomingHeader: h 
	"Add a header that references me"
	incomingHeaders add: h! !

!CPPFile methodsFor: 'adding' stamp: 'AlexandreBergel 11/7/2016 15:42'!
addOutgoingHeader: h
	"Add a header that is referenced by me"
	outgoingHeaders add: h! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 20:12'!
baseFilename
	^ (filename findTokens: '/') last
	 ! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:35'!
baseFilenameWithoutExtension
	| ts |
	ts := filename findTokens: '/.'.
	^ ts at: (ts size - 1)! !

!CPPFile methodsFor: 'gt inspector' stamp: 'AlexandreBergel 11/3/2016 20:18'!
gtInspectorContentsIn: composite
	<gtInspectorPresentationOrder: 5>
	fileReference ifNotNil: [ fileReference gtInspectorContentsIn: composite ]! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:34'!
includedNames
	"Return the list of names specified in the includes.
	For example, if the file contains #include <foo.h>
	Then the collection returned by includedName contains 'foo.h'"
	^ includedNames! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:34'!
incomingHeaders
	"Return the list of headers included by me"
	^ incomingHeaders! !

!CPPFile methodsFor: 'initialization' stamp: 'AlexandreBergel 11/7/2016 15:40'!
initialize
	super initialize.
	outgoingHeaders := OrderedCollection new.
	incomingHeaders := OrderedCollection new.
	includedNames := OrderedCollection new.
	self filename: 'UNAMED'.
	self loc: -1.! !

!CPPFile methodsFor: 'initialization' stamp: 'AlexandreBergel 11/3/2016 20:03'!
initializeFromContentAsString: string
	| lines includesLines |
	lines := string lines.
	loc := lines size.
	
	includesLines := lines select: [ :l | l beginsWith: '#include ' ].
	includesLines do: [ :l |
		includedNames add: (l findTokens: '<>"') second
	 ].
! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:35'!
loc
	"Return the number of lines of code of the file"
	^ loc! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:35'!
loc: anInteger
	"Set the number of lines of code of the file"
	loc := anInteger! !

!CPPFile methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:40'!
outgoingHeaders
	^ outgoingHeaders! !

!CPPFile methodsFor: 'printing' stamp: 'AlexandreBergel 11/3/2016 20:09'!
printOn: str
	super printOn: str.
	str nextPut: $<.
	filename notEmpty ifTrue: [ str nextPutAll: filename ].
	str nextPut: $>! !

CPPFile subclass: #CPPHeader
	instanceVariableNames: 'module'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer'!

!CPPHeader methodsFor: 'testing' stamp: 'AlexandreBergel 11/3/2016 19:29'!
hasModule
	^ module notNil! !

!CPPHeader methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:28'!
module
	^ module! !

!CPPHeader methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:28'!
module: anObject
	module := anObject! !

CPPFile subclass: #CPPModule
	instanceVariableNames: 'header dependentModules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer'!

!CPPModule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:29'!
dependentModules
	^ dependentModules! !

!CPPModule methodsFor: 'testing' stamp: 'AlexandreBergel 11/3/2016 19:29'!
hasHeader
	^ header notNil! !

!CPPModule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:29'!
header
	^ header! !

!CPPModule methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:29'!
header: anObject
	header := anObject! !

!CPPModule methodsFor: 'initialization' stamp: 'AlexandreBergel 11/3/2016 19:52'!
initialize
	super initialize.
	dependentModules := OrderedCollection new! !

CPPAbstractFile subclass: #CPPFolder
	instanceVariableNames: 'files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer'!

!CPPFolder methodsFor: 'adding' stamp: 'AlexandreBergel 11/7/2016 15:48'!
addFile: aFile
	files add: aFile! !

!CPPFolder methodsFor: 'accessing' stamp: 'AlexandreBergel 11/7/2016 15:48'!
files
	^ files copy! !

!CPPFolder methodsFor: 'initialization' stamp: 'AlexandreBergel 11/7/2016 15:47'!
initialize
	super initialize.
	files := OrderedCollection new! !

!CPPFolder methodsFor: 'metrics' stamp: 'AlexandreBergel 11/7/2016 15:48'!
numberOfFiles
	^ files size! !

RTObject subclass: #CPPProcessor
	instanceVariableNames: 'headers modules directories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2-Plugins-CProjectVisualizer'!

!CPPProcessor methodsFor: 'processing' stamp: 'AlexandreBergel 11/3/2016 20:13'!
headerNamed: afileName
	^ headers detect: [ :h | h baseFilename = afileName ] ifNone: [ nil ]! !

!CPPProcessor methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:19'!
headers
	^ headers! !

!CPPProcessor methodsFor: 'initialization' stamp: 'AlexandreBergel 11/7/2016 15:54'!
initialize
	super initialize.
	headers := OrderedCollection new.
	modules := OrderedCollection new.
	directories := OrderedCollection new! !

!CPPProcessor methodsFor: 'processing' stamp: 'AlexandreBergel 11/3/2016 20:12'!
moduleNamed: afileName
	^ modules detect: [ :m | m baseFilename = afileName ] ifNone: [ nil ]! !

!CPPProcessor methodsFor: 'accessing' stamp: 'AlexandreBergel 11/3/2016 19:19'!
modules
	^ modules! !

!CPPProcessor methodsFor: 'metrics' stamp: 'AlexandreBergel 11/7/2016 15:54'!
numberOfDirectories
	^ directories size! !

!CPPProcessor methodsFor: 'metrics' stamp: 'AlexandreBergel 11/3/2016 19:14'!
numberOfHeaders
	^ headers size! !

!CPPProcessor methodsFor: 'metrics' stamp: 'AlexandreBergel 11/3/2016 19:14'!
numberOfModules
	^ modules size! !

!CPPProcessor methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/7/2016 16:04'!
processDirectories: listOfDirectories

	"TODO"
	"Hum... Not sure whether we will keep the folders..."! !

!CPPProcessor methodsFor: 'processing' stamp: 'AlexandreBergel 11/3/2016 19:17'!
processFileAsString: fileContentAsString named: filename

	(filename endsWith: '.c') 
		ifTrue: [ ^ self processModuleAsString: fileContentAsString named: filename ].

	(filename endsWith: '.h') 
		ifTrue: [ ^ self processHeaderAsString: fileContentAsString named: filename ].
		! !

!CPPProcessor methodsFor: 'processing' stamp: 'AlexandreBergel 11/3/2016 19:20'!
processHeaderAsString: fileContentAsString named: filename 
	| h |
	h := CPPHeader new.
	h filename: filename.
	h initializeFromContentAsString: fileContentAsString.
	headers add: h! !

!CPPProcessor methodsFor: 'processing' stamp: 'AlexandreBergel 11/3/2016 19:20'!
processModuleAsString: fileContentAsString named: filename
	| m |
	m := CPPModule new.
	m filename: filename.
	m initializeFromContentAsString: fileContentAsString.
	modules add: m! !

!CPPProcessor methodsFor: 'processing' stamp: 'AlexandreBergel 11/7/2016 15:53'!
processRootFolder: aFileReference

	| relevantFiles allFiles allDirectories |
	allFiles := aFileReference allChildren.
	allDirectories := allFiles select: #isDirectory.
	self processDirectories: allDirectories.
	relevantFiles := allFiles select: [ :f | #('c' 'h' 'cpp') includes: f extension ].
	relevantFiles do: [ :f | 
			| r |
			r := f readStream.
			r ascii.
			r converter: Latin1TextConverter new.
			self processFileAsString: r contents named: f pathString ].! !

!CPPProcessor methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/3/2016 19:53'!
resolveDependencies

	self resolveDependenciesBetweenHeaderAndModule.
	self resolveDependenciesBetweenHeaders.
	self resolveDependenciesBetweenModules! !

!CPPProcessor methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/3/2016 19:37'!
resolveDependenciesBetweenHeaderAndModule

	
	| m |
	"We link header to modules, and modules to header"
	headers do: [ :h |
		m := self moduleNamed: h baseFilenameWithoutExtension, '.c'.
		m ifNotNil: [ m header: h. h module: m ]
	].! !

!CPPProcessor methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/3/2016 19:46'!
resolveDependenciesBetweenHeaders
	headers copy do: [ :h |
		h includedNames do: [ :name |
			| hh |
			hh := self headerNamed: name.
			hh ifNotNil: [ hh addIncomingHeader: h. h addOutgoingHeader: hh ] ]
	]! !

!CPPProcessor methodsFor: 'resolving dependencies' stamp: 'AlexandreBergel 11/3/2016 19:55'!
resolveDependenciesBetweenModules
	modules copy do: [ :m |
		m hasHeader ifTrue: [ 
			| oh |
			oh := m header outgoingHeaders. 
			oh := oh select: #hasModule thenCollect: #module.
			m dependentModules addAll: oh ]
	]! !
